package model

type DiscoveryZone struct {
	ExcludePatterns []string `json:"excludePatterns"`

	DiscoveryHost *DiscoveryHost `json:"discoveryHost"`
}

type DiscoveryHost struct {
	FirstScanRange string   `json:"firstScanRange"`
	LastScanRange  string   `json:"lastScanRange"`
	ExcludeHosts   []string `json:"excludeHosts"`

	DiscoveryPort *DiscoveryPort `json:"discoveryPort"`
}

type DiscoveryPort struct {
	FirstScanRange int   `json:"firstScanRange"`
	LastScanRange  int   `json:"lastScanRange"`
	ExcludePorts   []int `json:"excludePorts"`

	IncludeTCP bool `json:"includeTCP"`
	IncludeUDP bool `json:"includeUDP"`

	DiscoveryService *DiscoveryService `json:"discoveryService"`
}

type DiscoveryService struct {
	IncludeServices []string `json:"includeServices"`
}

/*
Dzone --> zone --> Dhost --> host --> Dport --> port --> Dservice --> service

zone --> Dhost --> host --> Dport --> port --> Dservice --> service

host --> Dport --> port --> Dservice --> service

port --> Dservice --> service
*/
