package mssql

import (
	"git.loafle.net/overflow/overflow_discovery/match/packet"
	"net"
	"testing"
)

/*
192.168.1.106:1433 - normal
192.168.1.103:1433 - ssl
*/
func TestSqlNor(t *testing.T) {

	conn, _ := net.Dial("tcp", "192.168.1.16:11433")

	defer conn.Close()

	sqlServerRun(conn, t)

}

//func TestSqlTLS(t *testing.T) {
//	conn, err := tls.Dial(
//		"tcp",
//		"192.168.1.103:7680",
//		&tls.Config{
//			InsecureSkipVerify: true,
//			ServerName:         "192.168.1.103",
//		},
//	)
//
//    if err != nil {
//        t.Log(err)
//        return
//    }
//
//	defer conn.Close()
//
//    sqlServerRun(conn, t)
//}

func sqlServerRun(conn net.Conn, t *testing.T) {

	m := NewMSSqlMatcher()

	for i := 0; i < m.PacketCount(); i++ {

		pack := m.Packet(i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := packet.NewPacket(bytes, n)

		if m.Match(i, p, nil) {
			t.Log(m.ServiceName())
			return
		}

		t.Error("MSSQL not found")
	}

}
