package imap

import (
	"git.loafle.net/overflow/overflow_discovery/service/matcher"
)

const (
	PRE_COMPARE_STR  = "* OK"
	SEND_COMPARE_STR = "* BYE"
)

type IMAPMatcher struct {
	matcher.Matchers
}

func (i *IMAPMatcher) ServiceName() string {
	return "IMAP"
}

func (i *IMAPMatcher) IsPrePacket() bool {
	return true
}

func (i *IMAPMatcher) HasResponse(index int) bool {
	return true
}

func (i *IMAPMatcher) IsError(info matcher.MatchInfo, index int, packet *matcher.Packet) bool {
	return false
}

func (i *IMAPMatcher) Match(info matcher.MatchInfo, index int, packet *matcher.Packet) bool {

	switch index {
	case 0:

		recvStr := string(packet.Buffer)

		if len(recvStr) < 3 {
			return false
		}

		compareStr := recvStr[0:4]

		if compareStr == PRE_COMPARE_STR {
			return true
		}

	case 1:

		recvStr := string(packet.Buffer)

		if len(recvStr) < 5 {
			return false
		}

		compareStr := recvStr[0:5]

		if compareStr == SEND_COMPARE_STR {
			return true
		}

	}

	return false
}

func NewMatcher() matcher.Matcher {

	m := &IMAPMatcher{}

	reqStr := "A0001 LOGOUT\r\n"
	byte := make([]byte, len(reqStr))
	copy(byte[:], reqStr)

	m.AddPacket(matcher.NewPacket(byte, len(reqStr)))

	return m

}
