package netbios

import (
	"net"
	"testing"

	"git.loafle.net/overflow/overflow_discovery/service/matcher"
)

func TestNBSS(t *testing.T) {

	m := NewMatcher()

	conn, _ := net.Dial("tcp", "192.168.1.106:139")

	defer conn.Close()

	for i := 0; i < m.PacketCount(); i++ {

		pack := m.Packet(i)
		conn.Write(pack.Buffer)
		bytes := make([]byte, 1024)
		n, _ := conn.Read(bytes)
		p := matcher.NewPacket(bytes, n)

		if m.Match(nil, i, p) {
			t.Log("NBSS found")
			return
		}

		t.Error("NBSS not found")
	}
}
