package ssh

import (
	"strings"

	"git.loafle.net/overflow/overflow_discovery/service/matcher"
)

type SSHMatcher struct {
	matcher.Matchers
}

func (ssh *SSHMatcher) ServiceName() string {
	return "SSH"
}

func (ssh *SSHMatcher) IsPrePacket() bool {
	return true
}

func (ssh *SSHMatcher) HasResponse(index int) bool {
	return true
}

func (ssh *SSHMatcher) IsError(info matcher.MatchInfo, index int, packet *matcher.Packet) bool {
	return false
}

func (ssh *SSHMatcher) Match(info matcher.MatchInfo, index int, packet *matcher.Packet) bool {
	result := false

	if packet == nil || packet.Buffer == nil || packet.Len == 0 {
		return result
	}

	str := string(packet.Buffer)

	//fmt.Println(str)
	temps := strings.Split(str, " ")
	protocol := strings.Split(temps[0], "-")
	//osType := temps[1]

	if 0 == strings.Compare(protocol[0], "SSH") {
		majorVersion := protocol[1]
		//fmt.Println(majorVersion)
		if 0 == strings.Compare(majorVersion, "2.0") || 0 == strings.Compare(majorVersion, "1.0") {
			result = true
		}
	}

	return result
}

func NewMatcher() matcher.Matcher {
	m := &SSHMatcher{}

	return m
}
